<?php
/**
 * SMF Arcade
 *
 * @package SMF Arcade
 * @version 2.55
 * @license https://web-develop.ca/index.php?page=arcade_license_BSD2 BSD 2
 */

if (!defined('SMF'))
	die('Hacking attempt...');

// Defiant sub-routines for narrow themes
function Arcade3champsBlock($no)
{
	global $scripturl, $txt, $settings;

	$top_player = ArcadeLatestChamps($no);
	$content = '
			<div class="centertext">
				<table style="width: 100%;border: 0px;border-collapse: collapse;">
					<tr>
						<td style="padding: 1px;" colspan="2">
							<div class="centertext"><i><strong>' . $no . '&nbsp;' . $txt['arcade_g_i_b_8'] . '</strong></i></div>
						</td>
					</tr>';
	if ($top_player != false)
	{
		foreach ($top_player as $row)
		{
			$content.= '
					<tr>
						<td colspan="2" style="height: 25px;padding: 1px;text-align: left;">
							<div style="padding: 0px;display: table-cell;font-size: x-small;vertical-align: center;">
								<img style="vertical-align: center;" src="' . $settings['default_images_url'] . '/arc_icons/cup_g.gif" alt="ico"/>
							</div>
							<div style="padding: 0px;display: table-cell;font-size: x-small;overflow: hidden;vertical-align: top;">
								<span style="padding-left: 3px;">' . $row['member_link'] . '&nbsp;' . $txt['is_champ_of'] . '&nbsp;' . $row['game_link'] . '</span>
							</div>
						</td>
					</tr>';
		}
	}
	$content.='
					<tr>
						<td style="display: none;">&nbsp;</td>
						<td style="display: none;">&nbsp;</td>
					</tr>
				</table>
			</div>';

	return $content;
}

function ArcadeRandomGameBlock()
{
	global $context, $txt, $modSettings, $settings;

	$gamex = small_game_query('ORDER BY RAND() LIMIT 0,1');
	$context['arcadeGameIconSizeDefiant'] = !empty($context['arcadeSkinAlt']) ? '40' : '60';
	foreach($gamex as $game)
	{
		$ratecode = '';
		$rating = $game['rating'];

		if ($rating > 0)
		{
			$ratecode = str_repeat('<img src="' . $settings['default_images_url'] . '/arc_icons/star.gif" alt="*" />' , $rating);
			$ratecode .= str_repeat('<img src="' . $settings['default_images_url'] . '/arc_icons/star2.gif" alt="*" />' , 5 - $rating);
		}

		$content = '
			<div class="centertext">
				<table style="width: 100%;border: 0px;border-collapse: collapse;">
					<tr>
						<td style="padding: 1px;">
							<div class="centertext"><i><b>' . $txt['arcade_random_game'] . '</b></i></div>
						</td>
					</tr>
					<tr>
						<td class="centertext" style="padding: 1px;">
							<div><span style="display: none;">&nbsp;</span></div>
							<a href="' . $game['url']['play'] . '">
								<img id="gameid' . $game['id'] . '" style="width: ' . $context['arcadeGameIconSizeDefiant'] . 'px;height: ' . $context['arcadeGameIconSizeDefiant'] . 'px;" src="' . $game['thumbnail'] . '" alt="" onerror="alternateArcadeImg(\'gameid' . $game['id'] . '\');" title="' . $txt['arcade_play'] . '&nbsp;' . $game['name'] . '"/>
							</a>
							<div><span style="display: none;">&nbsp;</span></div>
							<div style="font-size: x-small;">
								<a href="' . $game['url']['play'] . '">' . $game['name'] . '</a>
							</div>
						</td>
					</tr>';


		if ($rating > 0)
			$content .= '
					<tr>
						<td class="centertext" style="padding: 1px;">'.$ratecode.'</td>
					</tr>';

		$content .= '
					<tr>
						<td class="centertext" style="padding: 1px;">
							<div class="smalltext">';

		if ($game['isChampion'])
			$content .= '
								<span style="font-size: xx-small;"><strong>' . $txt['arcade_champion'] . ':</strong>&nbsp;'.$game['champion']['memberLink'].'&nbsp;->&nbsp;' . $game['champion']['score'] . '</span>';

		else
			$content .=$txt['arcade_no_scores'];

		$content .='
							</div>
						</td>
					</tr>
				</table>
			</div>';

		return $content;
	}
}


function ArcadeInfoNewestGames($no)
{
	global $smcFunc, $scripturl, $txt, $modSettings, $boardurl;

		$result = $smcFunc['db_query']('', '
		SELECT id_game, game_name, thumbnail, game_directory
		FROM {db_prefix}arcade_games
		WHERE enabled = 1
		ORDER BY id_game DESC
		LIMIT 0, {int:limit}',
		array(
		'limit' => $no,
		)
	);
	$content = '
			<div class="centertext">
				<table style="width: 100%;border: 0px;border-collapse: collapse;">
					<tr>
						<td style="padding: 3px;" colspan="2">
							<div class="centertext"><i><strong>' . $no . '&nbsp;' . $txt['arcade_LatestGames'] . '</strong></i></div>
						</td>
					</tr>';
	while ($popgame = $smcFunc['db_fetch_assoc']($result))
	{
		$gamesUrl = $boardurl . '/' . basename($modSettings['gamesUrl']);
		$popgameico = empty($popgame['game_directory']) ?	$gamesUrl . '/' . $popgame['thumbnail'] : $gamesUrl . '/' . $popgame['game_directory'] . '/' . $popgame['thumbnail'];
		$content .='
					<tr>
						<td style="padding: 7px 10px 3px 3px;">
							<div style="float: right;">
								<a href="' . $scripturl . '?action=arcade;sa=play;game=' . $popgame['id_game'] . '">
									<img id="popg' . $popgame['id_game'] . '" style="border: 0px;width: 25px;height: 25px;vertical-align: middle;" src="' . $popgameico. '" alt="&nbsp;" title="'.$txt['arcade_champions_play'].' '. $popgame['game_name'].'" onerror="alternateArcadeImg(\'popg' . $popgame['id_game'] . '\');" />
								</a>
							</div>
						</td>
						<td style="padding: 7px 3px 3px 0px;">
							<div style="float: left;font-size: x-small;padding-left: 2px;">
								<a href="' . $scripturl . '?action=arcade;sa=play;game=' . $popgame['id_game'] . '">' . $popgame['game_name'] . '</a>
							</div>
						</td>
					</tr>';
	}

	$content .='
					<tr>
						<td style="display: none;">&nbsp;</td>
						<td style="display: none;">&nbsp;</td>
					</tr>
				</table>
			</div>' ;

	return $content;
}

function ArcadeInfoLongestChamps($no)
{
	global $scripturl, $txt, $modSettings, $boardurl;

	$mostgame = ArcadeStats_LongestChampions($no);
	$i = 0;
	$content = '
			<div class="centertext">
				<table style="width: 100%;border: 0px;border-collapse: collapse;">
					<tr>
						<td style="padding: 0px;" colspan="2">
							<div class="centertext"><i><strong>' . $no . '&nbsp;' . $txt['arcade_g_i_b_11'] . '</strong></i></div>
						</td>
					</tr>';
	foreach($mostgame as $popgame)
	{
		$gamesUrl = $boardurl . '/' . basename($modSettings['gamesUrl']);
		$popgameico = empty($popgame['game_directory']) ?	$gamesUrl . '/' . $popgame['thumbnail'] : $gamesUrl . '/' . $popgame['game_directory'] . '/' . $popgame['thumbnail'];
		$content .=	'
					<tr>
						<td style="padding: 0px;width: 25px;">
							<a href="' . $scripturl.'?action=arcade;sa=play;game=' . $popgame['id'] . '">
								<img id="champgame' . $i . '" style="border: 0px;width: 25px;height: 25px;" src="' . $popgameico . '" onerror="alternateArcadeImg(\'champgame' . $i . '\');" alt="" title="' . $txt['arcade_champions_play'] . '&nbsp;' . $popgame['game_name'] . '"/>
							</a>
						</td>
						<td style="padding: 0px;font-size: x-small;padding-left: 2px;">
							<div style="text-align: left;position: relative;left: -15px;vertical-align: center;" title="' . $txt['arcade_g_i_b_5'] . '&nbsp;' . $popgame['duration'] . '">' . $popgame['member_link'] . '&nbsp;' . $txt['arcade_g_i_b_9'] . '&nbsp;' . $popgame['game_name'] . '</div>
						</td>
					</tr>';
		$i++;
	}

	$content .='
					<tr>
						<td style="display: none;">&nbsp;</td>
						<td style="display: none;">&nbsp;</td>
					</tr>
				</table>
			</div>' ;

	return $content;
}

function ArcadeInfoMostPlayed($no)
{
	global $scripturl, $txt, $modSettings, $boardurl;

	$mostgame = ArcadeStats_MostPlayed($no);
	$content = '
			<div class="centertext">
				<table style="width: 100%;border: 0px;border-collapse: collapse;">
					<tr>
						<td style="padding: 3px;" colspan="2">
							<div class="centertext"><i><strong>' . $no . '&nbsp;' . $txt['arcade_g_i_b_10'] . '</strong></i></div>
						</td>
					</tr>';
	foreach($mostgame as $popgame)
	{
		$gamesUrl = $boardurl . '/' . basename($modSettings['gamesUrl']);
		$popgameico = empty($popgame['game_directory']) ?	$gamesUrl . '/' . $popgame['thumbnail'] : $gamesUrl . '/' . $popgame['game_directory'] . '/' . $popgame['thumbnail'];
		$content .='
					<tr>
						<td style="padding: 7px 10px 3px 3px;">
							<div style="float: right;">
								<a href="' . $scripturl . '?action=arcade;sa=play;game=' . $popgame['id'] . '">
									<img id="popg' . $popgame['id'] . '" style="border: 0px;width: 25px;height: 25px;vertical-align: middle;" src="' . $popgameico. '" alt="&nbsp;" title="'.$txt['arcade_champions_play'].' '. $popgame['name'].'" onerror="alternateArcadeImg(\'popg' . $popgame['id'] . '\');" />
								</a>
							</div>
						</td>
						<td style="padding: 7px 3px 3px 0px;">
							<div style="float: left;font-size: x-small;padding-left: 2px;">
								<a href="' . $scripturl . '?action=arcade;sa=play;game=' . $popgame['id'] . '">' . $popgame['name'] . '</a>
							</div>
						</td>
					</tr>';
	}

	$content .='
					<tr>
						<td style="display: none;">&nbsp;</td>
						<td style="display: none;">&nbsp;</td>
					</tr>
				</table>
			</div>' ;

	return $content;
}

function ArcadeInfoBestPlayers($no)
{
	global $scripturl, $txt, $settings;

	$top_player = ArcadeStats_BestPlayers($no);
	$i=0; //players position

	//array for icons
	$poz = array(
		'cup_g.gif',
		'cup_s.gif',
		'cup_b.gif',
		'trophy.png'
	);

	$content = '
			<div class="centertext">
				<table style="width: 100%;border: 0px;border-collapse: collapse;">
					<tr>
						<td style="padding: 1px;" colspan="2">
							<div class="centertext"><i><b>' . $no . '&nbsp;' . $txt['arcade_b3pb_1'] . '</b></i></div>
						</td>
					</tr>';

	if ($top_player != false)
	{
		foreach ($top_player as $row)
		{
			$content.= '
					<tr>
						<td style="height: 25px;padding: 0px;margin: 0px;" colspan="2">
							<div style="display: table-cell;">
								<img src="' . $settings['default_images_url'] . '/arc_icons/' . $poz[$i] . '" alt="&nbsp;" style="vertical-align: center;" />
							</div>
							<div style="display: table-cell;font-size: x-small;vertical-align: top;">
								<span style="padding-left: 3px;">' . $row['link'] . '&nbsp;' . $txt['arcade_b3pb_2'] . '&nbsp;' . $row['champions'] . '&nbsp;' . $txt['arcade_b3pb_3'] . '</span>
							</div>
						</td>
					</tr>';
			$i++;
			if ($i > 2)
				$poz[$i]= 'trophy.png';
		}
	}
	$content.='
					<tr>
						<td style="display: none;">&nbsp;</td>
						<td style="display: none;">&nbsp;</td>
					</tr>
				</table>
			</div>';

	return $content;

}

function ArcadeGOTDBlock()
{
	global $context, $txt, $modSettings, $settings;

	list($ratecode, $game) = array('', getGameOfDay());
	$context['arcadeGameIconSizeDefiant'] = !empty($context['arcadeSkinAlt']) ? '40' : '60';
	$content = '
			<div class="centertext">
				<table style="width: 100%;border: 0px;">
					<tr>
						<td style="padding: 1px;">
							<div class="centertext"><i><b>' . $txt['arcade_game_of_day'] . '</b></i></div>
						</td>
					</tr>';
	$rating = !empty($game['rating']) ? (int)$game['rating'] : 0;

	if ($rating > 0)
	{
		$ratecode = str_repeat('<img src="' . $settings['default_images_url'] . '/arc_icons/star.gif" alt="s" />' , $rating);
		$ratecode .= str_repeat('<img src="' . $settings['default_images_url'] . '/arc_icons/star2.gif" alt="s" />' , 5 - $rating);
	}

	$content .= '
					<tr>
						<td style="padding: 1px;">
							<div class="centertext">';

	if (!empty($game['thumbnail']))
		$content .= '
								<div><span style="display: none;">&nbsp;</span></div>
								<a href="' . $game['url']['play'] . '">
									<img id="gotd' . $game['id'] . '" style="width: ' . $context['arcadeGameIconSizeDefiant'] . 'px;height: ' . $context['arcadeGameIconSizeDefiant'] . 'px;" src="' . $game['thumbnail'] . '" onerror="alternateArcadeImg(\'gotd' . $game['id'] . '\');" alt="" title="'.$txt['arcade_play'].' '.$game['name'].'" />
								</a>
								<div><span style="display: none;">&nbsp;</span></div>
								<div><span style="display: none;">&nbsp;</span></div>';

	$content .= '
								<div class="smalltext"><a href="'. $game['url']['play']. '">'. $game['name']. '</a></div>
							</div>
						</td>
					</tr>';

	if ($rating > 0)
		$content .= '
					<tr>
						<td class="centertext">' . $ratecode . '</td>
					</tr>';

	$content .= '
					<tr>
						<td class="centertext">
							<div class="smalltext">';

	if (!empty($game['is_champion']))
		$content .= '
								<span style="font-size: xx-small;"><strong>' . $txt['arcade_champion'] . ':</strong> ' . $game['champion']['link']. '&nbsp;->&nbsp;' . $game['champion']['score'] . '</span>';
	else
		$content .= $txt['arcade_no_scores'];

	$content .= '
							</div>
						</td>
					</tr>
				</table>
			</div>';
	return $content;
}
?>